package cn.ibizlab.core.sample.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.core.sample.domain.IBIZTASK;
import cn.ibizlab.core.sample.filter.IBIZTASKSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[IBIZTASK] 服务对象接口
 */
public interface IIBIZTASKService extends IService<IBIZTASK> {

    boolean create(IBIZTASK et);
    void createBatch(List<IBIZTASK> list);
    boolean update(IBIZTASK et);
    void updateBatch(List<IBIZTASK> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    IBIZTASK get(String key);
    IBIZTASK getDraft(IBIZTASK et);
    boolean checkKey(IBIZTASK et);
    boolean save(IBIZTASK et);
    void saveBatch(List<IBIZTASK> list);
    Page<IBIZTASK> searchDefault(IBIZTASKSearchContext context);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<IBIZTASK> getIbiztaskByIds(List<String> ids);
    List<IBIZTASK> getIbiztaskByEntities(List<IBIZTASK> entities);
}


